- name: graylog setup
  hosts: localhost
  vars:
     - ansible_user: root
     - ansible_connection: local

  tasks:
  - name: set hostname based on instance launch date/time
    shell:  curl 169.254.169.254/latest/dynamic/instance-identity/document/ 2> /dev/null | grep pending | cut -d ":" -f 2- | cut -d \n -f 1 | cut -d "T" -f 1- | sed 's/[Z,:"-]//g'
    changed_when: no
    register: launch

  - name: set hostname based on instance launch date/time
    shell: hostnamectl set-hostname graylog-"{{launch.stdout}}"

  - name: find public url of instance
    shell: curl 169.254.169.254/latest/meta-data/public-hostname
    changed_when: no
    register: publichostname
    notify: restart nginx                        

  - name: install epel and graylog repos
    yum: 
       name:
       - https://dl.fedoraproject.org/pub/epel/epel-release-latest-7.noarch.rpm 
       - https://packages.graylog2.org/repo/packages/graylog-2.4-repository_latest.rpm
       state: installed

  - name: install mongodb repo
    yum_repository:
        name: mongo
        description: "MongoDB repo"
        baseurl: https://repo.mongodb.org/yum/redhat/7Server/mongodb-org/3.6/x86_64/
        gpgkey: https://www.mongodb.org/static/pgp/server-3.6.asc
        enabled: yes

  - name: install required packages
    yum:
        name: 
            - graylog-server
            - java-openjdk-headless
            - mongodb-org
            - nginx
            - python-pip
            - jq
        state: latest

  #Script to extract list of ec2 instances in auto-scalinggroup by IP address. This will become the string of mongo connections and will set up the mongo replicaset
  - name: list running instances in autoscaling group pt 1
    copy: 
       dest: /usr/local/bin/describe_asg
       mode: 0755
       content: |
        #!/bin/bash
        instances=$(aws autoscaling describe-auto-scaling-groups --output=text | grep INSTANCES | grep InService | cut  -f 4)
        aws ec2 describe-instances --instance-ids $instances --query 'Reservations[*].Instances[*].[LaunchTime, InstanceId, PrivateIpAddress]' --output text | sort -u > /var/local/instancegroup
        curl http://169.254.169.254/latest/meta-data/instance-id > /var/local/instanceid
        read -r firstline < /var/local/instancegroup && echo $firstline |  cut -d " " -f 2 > /var/local/masterid
        instanceid=$(cat /var/local/instanceid)
        masterid=$(cat /var/local/masterid)
        if [ "$instanceid" == "$masterid" ]; then 
            touch /var/local/ismaster
        else
            rm -f /var/local/ismaster
        fi

  - name: list running instances in autoscaling group  pt 2
    shell: /usr/local/bin/describe_asg
    failed_when: false
    changed_when: false

  - name: determine whether this instance should be the master
    stat: 
       path: /var/local/ismaster
    register: mastertest

  - name: set as master if above is true
    set_fact:
         master: true
    when: mastertest.stat.exists
                     
  - name: nginx configuration
    copy:
        dest: /etc/nginx/nginx.conf
        content: |
           user nginx;
           worker_processes auto;
           error_log /var/log/nginx/error.log;
           pid /run/nginx.pid;
           include /usr/share/nginx/modules/*.conf;
           events {
           worker_connections 1024;
           }
           http {
           log_format  main  '$remote_addr - $remote_user [$time_local] "$request" '
           '$status $body_bytes_sent "$http_referer" '
           '"$http_user_agent" "$http_x_forwarded_for"';
              
           access_log  /var/log/nginx/access.log  main;
                            
           sendfile            on;
           tcp_nopush          on;
           tcp_nodelay         on;
           keepalive_timeout   65;
           types_hash_max_size 2048;
                            
           include             /etc/nginx/mime.types;
           default_type        application/octet-stream;
                            
           include /etc/nginx/conf.d/*.conf;
                             
           server {
                  listen       80 default_server;
                  listen       [::]:80 default_server;
                  server_name  _;
                  root         /usr/share/nginx/html;
              
                  # Load configuration files for the default server block.
                  include /etc/nginx/default.d/*.conf;
                            
                 location / {
                     proxy_set_header Host \$http_host;
                     proxy_set_header X-Forwarded-Host \$host;
                     proxy_set_header X-Forwarded-Server \$host;
                     proxy_set_header X-Forwarded-For \$proxy_add_x_forwarded_for;
                     proxy_set_header X-Graylog-Server-URL http://{{publichostname.stdout}}/api;
                     proxy_pass       http://127.0.0.1:9000;
                     }
                             
                            
                 error_page 404 /404.html;
                 location = /40x.html {
                   }
                             
                 error_page 500 502 503 504 /50x.html;
                 location = /50x.html {
                                    }
               	}
                }
    notify: restart nginx

  - name: graylog nodename based on hostname
    copy: 
       dest: /etc/graylog/server/node-id
       content: graylog-{{launch.stdout}}

  - name: mongo connections string
    shell: "cat /var/local/instancegroup  | cut -f 3 | paste -s -d,"
    register: mongostring
    tags: mongostring

  - name: graylog configuration
    copy:
       dest: /etc/graylog/server/server.conf
       content: |
              is_master = {{master | default(false)}}
              node_id_file = /etc/graylog/server/node-id
              password_secret = gkbgksdhbfjabfwbjgasvdfsdjbgasjvfhsdjbghjvcfsdgnvsdhkvcasuvfasdb
              #root_username = admin
              root_password_sha2 = 7bcf94a22f44edd39838d05ee1811869f19eca8797a0e9699fe149ba0c1066b4 
              #root_email = ""
              #root_timezone = UTC
              plugin_dir = /usr/share/graylog-server/plugin
              rest_listen_uri = http://127.0.0.1:9000/api/
              #rest_transport_uri = http://192.168.1.1:9000/api/
              #rest_enable_cors = false
              #rest_enable_gzip = false
              #rest_enable_tls = true
              #rest_tls_cert_file = /path/to/graylog.crt
              #rest_tls_key_file = /path/to/graylog.key
              #rest_tls_key_password = secret
              #rest_max_header_size = 8192
              #rest_thread_pool_size = 16
              #trusted_proxies = 127.0.0.1/32, 0:0:0:0:0:0:0:1/128
              web_enable = true
              web_listen_uri = http://127.0.0.1:9000/
              web_endpoint_uri = http://127.0.0.1:9000/api
              #web_enable_cors = false
              #web_enable_gzip = false
              #web_enable_tls = true
              #web_tls_cert_file = /path/to/graylog-web.crt
              #web_tls_key_file = /path/to/graylog-web.key
              #web_tls_key_password = secret
              #web_max_header_size = 8192
              #web_thread_pool_size = 16
              #elasticsearch_hosts = http://node1:9200,http://user:password@node2:19200
              elasticsearch_hosts = https://${GraylogElasticsearch.DomainEndpoint}:443
              #elasticsearch_connect_timeout = 10s
              #elasticsearch_socket_timeout = 60s
              #elasticsearch_idle_timeout = -1s
              #elasticsearch_max_total_connections = 20
              #elasticsearch_max_total_connections_per_route = 2
              #elasticsearch_max_retries = 2
              #elasticsearch_discovery_enabled = true
              #elasticsearch_discovery_filter = rack:42
              #elasticsearch_discovery_frequency = 30s
              #elasticsearch_compression_enabled = true
              rotation_strategy = count
              elasticsearch_max_docs_per_index = 20000000
              #elasticsearch_max_size_per_index = 1073741824
              #elasticsearch_max_time_per_index = 1d
              #elasticsearch_disable_version_check = true
              #no_retention = false
              elasticsearch_max_number_of_indices = 20
              retention_strategy = delete
              elasticsearch_shards = 4
              elasticsearch_replicas = 1
              elasticsearch_index_prefix = graylog
              #elasticsearch_template_name = graylog-internal
              allow_leading_wildcard_searches = false
              allow_highlighting = false
              elasticsearch_analyzer = standard
              #elasticsearch_request_timeout = 1m
              #elasticsearch_index_optimization_timeout = 1h
              #elasticsearch_index_optimization_jobs = 20
              #index_ranges_cleanup_interval = 1h
              output_batch_size = 500
              output_flush_interval = 1
              output_fault_count_threshold = 5
              output_fault_penalty_seconds = 30
              processbuffer_processors = 5
              outputbuffer_processors = 3
              #outputbuffer_processor_keep_alive_time = 5000
              #outputbuffer_processor_threads_core_pool_size = 3
              #outputbuffer_processor_threads_max_pool_size = 30
              #udp_recvbuffer_sizes = 1048576
              processor_wait_strategy = blocking
              ring_size = 65536
              inputbuffer_ring_size = 65536
              inputbuffer_processors = 2
              inputbuffer_wait_strategy = blocking
              message_journal_enabled = true
              message_journal_dir = /var/lib/graylog-server/journal
              #message_journal_max_age = 12h
              #message_journal_max_size = 5gb
              #message_journal_flush_age = 1m
              #message_journal_flush_interval = 1000000
              #message_journal_segment_age = 1h
              #message_journal_segment_size = 100mb
              #async_eventbus_processors = 2
              lb_recognition_period_seconds = 3
              #lb_throttle_threshold_percentage = 95
              #stream_processing_timeout = 2000
              #stream_processing_max_faults = 3
              #alert_check_interval = 60
              #output_module_timeout = 10000
              #stale_master_timeout = 2000
              #shutdown_timeout = 30000
              mongodb_uri = mongodb://{{mongostring.stdout}}/graylog
              #mongodb_uri = mongodb://grayloguser:secret@localhost:27017/graylog 
              #mongodb_uri = mongodb://grayloguser:secret@localhost:27017,localhost:27018,localhost:27019/graylog
              mongodb_max_connections = 1000
              mongodb_threads_allowed_to_block_multiplier = 5
              #rules_file = /etc/graylog/server/rules.drl
              #transport_email_enabled = false
              #transport_email_hostname = mail.example.com
              #transport_email_port = 587
              #transport_email_use_auth = true
              #transport_email_use_tls = true
              #transport_email_use_ssl = true
              #transport_email_auth_username = you@example.com
              #transport_email_auth_password = secret
              #transport_email_subject_prefix = [graylog]
              #transport_email_from_email = graylog@example.com
              #transport_email_web_interface_url = https://graylog.example.com
              #http_connect_timeout = 5s
              #http_read_timeout = 10s
              #http_write_timeout = 10s
              #http_proxy_uri =
              #http_non_proxy_hosts =
              #disable_index_optimization = true
              # Optimize the index down to <= index_optimization_max_num_segments. A higher number may take some load from Elasticsearch
              #index_optimization_max_num_segments = 1
              #gc_warning_threshold = 1s
              #ldap_connection_timeout = 2000
              #disable_sigar = false
              #dashboard_widget_default_cache_time = 10s
              #content_packs_loader_enabled = true
              content_packs_dir = /usr/share/graylog-server/contentpacks
              content_packs_auto_load = grok-patterns.json
              proxied_requests_thread_pool_size = 32
    notify: restart graylog

  - name: mongod config
    copy:
        dest: /etc/mongod.conf
        content: |
          # mongod.conf
          # for documentation of all options, see:
          # http://docs.mongodb.org/manual/reference/configuration-options/
          # where to write logging data.
          systemLog:
             destination: file
             logAppend: true
             path: /var/log/mongodb/mongod.log
          # Where and how to store data.
          storage:
             dbPath: /var/lib/mongo
             journal:
               enabled: true
          #  engine:
          #  mmapv1:
          #  wiredTiger:
          # how the process runs
          processManagement:
              fork: true  # fork and run in background
              pidFilePath: /var/run/mongodb/mongod.pid  # location of pidfile
              timeZoneInfo: /usr/share/zoneinfo
          # network interfaces
          net:
            port: 27017
            bindIp: 0.0.0.0
          #security:
          #operationProfiling:
          replication:
             replSetName: "graylog"
          #sharding:
          ## Enterprise-Only Options
          #auditLog:
          #snmp:     
    notify: restart mongod    

  - name: cron job to regularly rerun this playbook to pick up changes to environment
    cron:
        user: root
        job: /usr/bin/ansible-playbook /root/bootstrap.yml >> /var/log/bootstrap
        minute: "0,10,20,30,40,50"
        cron_file: bootstrap
   
  - name: selinux boolean soft requirement
    seboolean:
        name: httpd_can_network_connect
        state: yes
        persistent: yes
  
  - name: mongod is running and enabled
    service: 
         name: mongod
         state: started
         enabled: yes

  - name: initiate mongo and add other members if this is the master
    shell: /root/mongoinstall.sh
    when: mastertest.stat.exists


  - name: graylog is running and enabled
    service: 
         name: graylog-server
         state: started
         enabled: yes

  - name: nginx is running and enabled
    service: 
        name: nginx
        state: started
        enabled: yes  

  handlers:
  - name: restart graylog
    service:
       name: graylog-server
       enabled: yes
       state: restarted
  - name: restart nginx
    service:
       name: nginx
       state: restarted

  - name: restart mongod
    service:
       name: mongod
       state: restarted
